import http from 'http';
import https from 'https';
import url from 'url';
import stream from 'stream';
import assert from 'assert';
import zlib from 'zlib';
import crypto from 'crypto';
import React, { Component } from 'react';
import PropTypes from 'prop-types';

var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

function unwrapExports (x) {
	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
}

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var dist = createCommonjsModule(function (module, exports) {
/*!
 * 
 *         @Copyright (c) 2019-present, Zabo & Modular, Inc. All rights reserved.
 * 
 *         Licensed under the Apache License, Version 2.0 (the "License");
 *         you may not use this file except in compliance with the License.
 *         You may obtain a copy of the License at
 * 
 *         http://www.apache.org/licenses/LICENSE-2.0
 * 
 *         Unless required by applicable law or agreed to in writing, software
 *         distributed under the License is distributed on an "AS IS" BASIS,
 *         WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *         See the License for the specific language governing permissions and
 *         limitations under the License.
 * 
 *         @Version: "1.1.0"
 *       
 */
!function(e,t){module.exports=t();}("undefined"!=typeof self?self:commonjsGlobal,(function(){return function(e){var t={};function r(s){if(t[s])return t[s].exports;var o=t[s]={i:s,l:!1,exports:{}};return e[s].call(o.exports,o,o.exports,r),o.l=!0,o.exports}return r.m=e,r.c=t,r.d=function(e,t,s){r.o(e,t)||Object.defineProperty(e,t,{enumerable:!0,get:s});},r.r=function(e){"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(e,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(e,"__esModule",{value:!0});},r.t=function(e,t){if(1&t&&(e=r(e)),8&t)return e;if(4&t&&"object"==typeof e&&e&&e.__esModule)return e;var s=Object.create(null);if(r.r(s),Object.defineProperty(s,"default",{enumerable:!0,value:e}),2&t&&"string"!=typeof e)for(var o in e)r.d(s,o,function(t){return e[t]}.bind(null,o));return s},r.n=function(e){var t=e&&e.__esModule?function(){return e.default}:function(){return e};return r.d(t,"a",t),t},r.o=function(e,t){return Object.prototype.hasOwnProperty.call(e,t)},r.p="",r(r.s=21)}([function(e,t,r){var s=r(5),o=Object.prototype.toString;function n(e){return "[object Array]"===o.call(e)}function i(e){return void 0===e}function a(e){return null!==e&&"object"==typeof e}function c(e){if("[object Object]"!==o.call(e))return !1;var t=Object.getPrototypeOf(e);return null===t||t===Object.prototype}function u(e){return "[object Function]"===o.call(e)}function h(e,t){if(null!=e)if("object"!=typeof e&&(e=[e]),n(e))for(var r=0,s=e.length;r<s;r++)t.call(null,e[r],r,e);else for(var o in e)Object.prototype.hasOwnProperty.call(e,o)&&t.call(null,e[o],o,e);}e.exports={isArray:n,isArrayBuffer:function(e){return "[object ArrayBuffer]"===o.call(e)},isBuffer:function(e){return null!==e&&!i(e)&&null!==e.constructor&&!i(e.constructor)&&"function"==typeof e.constructor.isBuffer&&e.constructor.isBuffer(e)},isFormData:function(e){return "undefined"!=typeof FormData&&e instanceof FormData},isArrayBufferView:function(e){return "undefined"!=typeof ArrayBuffer&&ArrayBuffer.isView?ArrayBuffer.isView(e):e&&e.buffer&&e.buffer instanceof ArrayBuffer},isString:function(e){return "string"==typeof e},isNumber:function(e){return "number"==typeof e},isObject:a,isPlainObject:c,isUndefined:i,isDate:function(e){return "[object Date]"===o.call(e)},isFile:function(e){return "[object File]"===o.call(e)},isBlob:function(e){return "[object Blob]"===o.call(e)},isFunction:u,isStream:function(e){return a(e)&&u(e.pipe)},isURLSearchParams:function(e){return "undefined"!=typeof URLSearchParams&&e instanceof URLSearchParams},isStandardBrowserEnv:function(){return ("undefined"==typeof navigator||"ReactNative"!==navigator.product&&"NativeScript"!==navigator.product&&"NS"!==navigator.product)&&("undefined"!=typeof window&&"undefined"!=typeof document)},forEach:h,merge:function e(){var t={};function r(r,s){c(t[s])&&c(r)?t[s]=e(t[s],r):c(r)?t[s]=e({},r):n(r)?t[s]=r.slice():t[s]=r;}for(var s=0,o=arguments.length;s<o;s++)h(arguments[s],r);return t},extend:function(e,t,r){return h(t,(function(t,o){e[o]=r&&"function"==typeof t?s(t,r):t;})),e},trim:function(e){return e.replace(/^\s*/,"").replace(/\s*$/,"")},stripBOM:function(e){return 65279===e.charCodeAt(0)&&(e=e.slice(1)),e}};},function(e,t,r){class s extends Error{constructor(e,t,r,...o){return super(t,...o),Error.captureStackTrace&&Error.captureStackTrace(this,s),this.error_type=e,this.request_id=r,this}}e.exports={SDKError:s};},function(e,t,r){const s=r(47),{SDKError:o}=r(1),n=/^[0-9a-f]{8}-[0-9a-f]{4}-[1-5][0-9a-f]{3}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function i(e,t,r,s){const o=t?encodeURIComponent(t):"",n=r?"; expires="+r:"",i="; path="+(s||"/");document.cookie=encodeURIComponent(e)+"="+o+n+i;}function a(e){const t=new RegExp("(?:(?:^|.*;)\\s*"+encodeURIComponent(e).replace(/[-.+*]/g,"\\$&")+"\\s*\\=\\s*([^;]*).*$)|^.*$");return decodeURIComponent(document.cookie.replace(t,"$1"))||null}function c(e){if("string"!=typeof e)return !1;if(e=e.toLowerCase(),!n.test(e))return !1;switch(0|e.charAt(14)){case 1:case 2:return !0;case 3:case 4:case 5:return -1!==["8","9","a","b"].indexOf(e.charAt(19));default:return !1}}const u=new Function("return typeof window !== 'undefined'"),h=new Function("return typeof global !== 'undefined'");e.exports={generateHMACSignature:function(e,t,r,o){const n=o+t+r;return s("sha256",e).update(n).digest("hex")},setCookie:i,getCookie:a,deleteCookie:function(e,t){i(e,null,"Thu, 01 Jan 1970 00:00:01 GMT",t);},getZaboSession:function(){return a("zabosession")},uuidValidate:c,validateListParameters:function(e,t){if(e&&e>50)throw new o(400,"[Zabo] Values for `limit` must be 50 or below. See: https://zabo.com/docs#pagination");if(t&&!c(t))throw new o(400,"[Zabo] `cursor` must be a valid UUID version 4. See: https://zabo.com/docs#pagination")},validateEnumParameter:function(e,t,r,s=!1){if(!s&&void 0===t)throw new o(400,`[Zabo] Missing \`${e}\` parameter.`);if(!r.includes(t))throw new o(400,`[Zabo] Invalid \`${e}\` parameter. Available options: "${r.join('", "')}".`)},createPaginator:function(e,t){const{list_cursor:r={},...s}=e||{};function o(e){Object.assign(this,e||{});}return o.prototype.hasMore=r.has_more,o.prototype.limit=r.limit,o.prototype.next=async function(){return r.has_more&&r.next_uri?t.request("GET",r.next_uri):new o},new o(s)},sleep:function(e){return new Promise(t=>setTimeout(t,e))},isBrowser:u,isNode:h};},function(e,t,r){var s=r(0);function o(e){return encodeURIComponent(e).replace(/%3A/gi,":").replace(/%24/g,"$").replace(/%2C/gi,",").replace(/%20/g,"+").replace(/%5B/gi,"[").replace(/%5D/gi,"]")}e.exports=function(e,t,r){if(!t)return e;var n;if(r)n=r(t);else if(s.isURLSearchParams(t))n=t.toString();else{var i=[];s.forEach(t,(function(e,t){null!=e&&(s.isArray(e)?t+="[]":e=[e],s.forEach(e,(function(e){s.isDate(e)?e=e.toISOString():s.isObject(e)&&(e=JSON.stringify(e)),i.push(o(t)+"="+o(e));})));})),n=i.join("&");}if(n){var a=e.indexOf("#");-1!==a&&(e=e.slice(0,a)),e+=(-1===e.indexOf("?")?"?":"&")+n;}return e};},function(e,t,r){var s=r(9);e.exports=function(e,t,r,o,n){var i=new Error(e);return s(i,t,r,o,n)};},function(e,t,r){e.exports=function(e,t){return function(){for(var r=new Array(arguments.length),s=0;s<r.length;s++)r[s]=arguments[s];return e.apply(t,r)}};},function(e,t,r){e.exports=function(e){return !(!e||!e.__CANCEL__)};},function(e,t,r){var s=r(0),o=r(30),n={"Content-Type":"application/x-www-form-urlencoded"};function i(e,t){!s.isUndefined(e)&&s.isUndefined(e["Content-Type"])&&(e["Content-Type"]=t);}var a,c={adapter:("undefined"!=typeof XMLHttpRequest?a=r(31):"undefined"!=typeof process&&"[object process]"===Object.prototype.toString.call(process)&&(a=r(37)),a),transformRequest:[function(e,t){return o(t,"Accept"),o(t,"Content-Type"),s.isFormData(e)||s.isArrayBuffer(e)||s.isBuffer(e)||s.isStream(e)||s.isFile(e)||s.isBlob(e)?e:s.isArrayBufferView(e)?e.buffer:s.isURLSearchParams(e)?(i(t,"application/x-www-form-urlencoded;charset=utf-8"),e.toString()):s.isObject(e)?(i(t,"application/json;charset=utf-8"),JSON.stringify(e)):e}],transformResponse:[function(e){if("string"==typeof e)try{e=JSON.parse(e);}catch(e){}return e}],timeout:0,xsrfCookieName:"XSRF-TOKEN",xsrfHeaderName:"X-XSRF-TOKEN",maxContentLength:-1,maxBodyLength:-1,validateStatus:function(e){return e>=200&&e<300}};c.headers={common:{Accept:"application/json, text/plain, */*"}},s.forEach(["delete","get","head"],(function(e){c.headers[e]={};})),s.forEach(["post","put","patch"],(function(e){c.headers[e]=s.merge(n);})),e.exports=c;},function(e,t,r){var s=r(4);e.exports=function(e,t,r){var o=r.config.validateStatus;r.status&&o&&!o(r.status)?t(s("Request failed with status code "+r.status,r.config,null,r.request,r)):e(r);};},function(e,t,r){e.exports=function(e,t,r,s,o){return e.config=t,r&&(e.code=r),e.request=s,e.response=o,e.isAxiosError=!0,e.toJSON=function(){return {message:this.message,name:this.name,description:this.description,number:this.number,fileName:this.fileName,lineNumber:this.lineNumber,columnNumber:this.columnNumber,stack:this.stack,config:this.config,code:this.code}},e};},function(e,t,r){var s=r(33),o=r(34);e.exports=function(e,t){return e&&!s(t)?o(e,t):t};},function(e,t){e.exports=http;},function(e,t){e.exports=https;},function(e,t,r){var s=r(14),o=s.URL,n=r(11),i=r(12),a=r(38).Writable,c=r(39),u=r(40),h=Object.create(null);["abort","aborted","connect","error","socket","timeout"].forEach((function(e){h[e]=function(t,r,s){this._redirectable.emit(e,t,r,s);};}));var d=E("ERR_FR_REDIRECTION_FAILURE",""),p=E("ERR_FR_TOO_MANY_REDIRECTS","Maximum number of redirects exceeded"),f=E("ERR_FR_MAX_BODY_LENGTH_EXCEEDED","Request body larger than maxBodyLength limit"),l=E("ERR_STREAM_WRITE_AFTER_END","write after end");function m(e,t){a.call(this),this._sanitizeOptions(e),this._options=e,this._ended=!1,this._ending=!1,this._redirectCount=0,this._redirects=[],this._requestBodyLength=0,this._requestBodyBuffers=[],t&&this.on("response",t);var r=this;this._onNativeResponse=function(e){r._processResponse(e);},this._performRequest();}function g(e,t){clearTimeout(e._timeout),e._timeout=setTimeout((function(){e.emit("timeout");}),t);}function b(){clearTimeout(this._timeout);}function w(e){var t={maxRedirects:21,maxBodyLength:10485760},r={};return Object.keys(e).forEach((function(n){var i=n+":",a=r[i]=e[n],h=t[n]=Object.create(a);Object.defineProperties(h,{request:{value:function(e,n,a){if("string"==typeof e){var h=e;try{e=_(new o(h));}catch(t){e=s.parse(h);}}else o&&e instanceof o?e=_(e):(a=n,n=e,e={protocol:i});return "function"==typeof n&&(a=n,n=null),(n=Object.assign({maxRedirects:t.maxRedirects,maxBodyLength:t.maxBodyLength},e,n)).nativeProtocols=r,c.equal(n.protocol,i,"protocol mismatch"),u("options",n),new m(n,a)},configurable:!0,enumerable:!0,writable:!0},get:{value:function(e,t,r){var s=h.request(e,t,r);return s.end(),s},configurable:!0,enumerable:!0,writable:!0}});})),t}function y(){}function _(e){var t={protocol:e.protocol,hostname:e.hostname.startsWith("[")?e.hostname.slice(1,-1):e.hostname,hash:e.hash,search:e.search,pathname:e.pathname,path:e.pathname+e.search,href:e.href};return ""!==e.port&&(t.port=Number(e.port)),t}function v(e,t){var r;for(var s in t)e.test(s)&&(r=t[s],delete t[s]);return r}function E(e,t){function r(e){Error.captureStackTrace(this,this.constructor),this.message=e||t;}return r.prototype=new Error,r.prototype.constructor=r,r.prototype.name="Error ["+e+"]",r.prototype.code=e,r}m.prototype=Object.create(a.prototype),m.prototype.write=function(e,t,r){if(this._ending)throw new l;if(!("string"==typeof e||"object"==typeof e&&"length"in e))throw new TypeError("data should be a string, Buffer or Uint8Array");"function"==typeof t&&(r=t,t=null),0!==e.length?this._requestBodyLength+e.length<=this._options.maxBodyLength?(this._requestBodyLength+=e.length,this._requestBodyBuffers.push({data:e,encoding:t}),this._currentRequest.write(e,t,r)):(this.emit("error",new f),this.abort()):r&&r();},m.prototype.end=function(e,t,r){if("function"==typeof e?(r=e,e=t=null):"function"==typeof t&&(r=t,t=null),e){var s=this,o=this._currentRequest;this.write(e,t,(function(){s._ended=!0,o.end(null,null,r);})),this._ending=!0;}else this._ended=this._ending=!0,this._currentRequest.end(null,null,r);},m.prototype.setHeader=function(e,t){this._options.headers[e]=t,this._currentRequest.setHeader(e,t);},m.prototype.removeHeader=function(e){delete this._options.headers[e],this._currentRequest.removeHeader(e);},m.prototype.setTimeout=function(e,t){if(t&&this.once("timeout",t),this.socket)g(this,e);else{var r=this;this._currentRequest.once("socket",(function(){g(r,e);}));}return this.once("response",b),this.once("error",b),this},["abort","flushHeaders","getHeader","setNoDelay","setSocketKeepAlive"].forEach((function(e){m.prototype[e]=function(t,r){return this._currentRequest[e](t,r)};})),["aborted","connection","socket"].forEach((function(e){Object.defineProperty(m.prototype,e,{get:function(){return this._currentRequest[e]}});})),m.prototype._sanitizeOptions=function(e){if(e.headers||(e.headers={}),e.host&&(e.hostname||(e.hostname=e.host),delete e.host),!e.pathname&&e.path){var t=e.path.indexOf("?");t<0?e.pathname=e.path:(e.pathname=e.path.substring(0,t),e.search=e.path.substring(t));}},m.prototype._performRequest=function(){var e=this._options.protocol,t=this._options.nativeProtocols[e];if(t){if(this._options.agents){var r=e.substr(0,e.length-1);this._options.agent=this._options.agents[r];}var o=this._currentRequest=t.request(this._options,this._onNativeResponse);for(var n in this._currentUrl=s.format(this._options),o._redirectable=this,h)n&&o.on(n,h[n]);if(this._isRedirect){var i=0,a=this,c=this._requestBodyBuffers;!function e(t){if(o===a._currentRequest)if(t)a.emit("error",t);else if(i<c.length){var r=c[i++];o.finished||o.write(r.data,r.encoding,e);}else a._ended&&o.end();}();}}else this.emit("error",new TypeError("Unsupported protocol "+e));},m.prototype._processResponse=function(e){var t=e.statusCode;this._options.trackRedirects&&this._redirects.push({url:this._currentUrl,headers:e.headers,statusCode:t});var r=e.headers.location;if(r&&!1!==this._options.followRedirects&&t>=300&&t<400){if(this._currentRequest.removeAllListeners(),this._currentRequest.on("error",y),this._currentRequest.abort(),e.destroy(),++this._redirectCount>this._options.maxRedirects)return void this.emit("error",new p);((301===t||302===t)&&"POST"===this._options.method||303===t&&!/^(?:GET|HEAD)$/.test(this._options.method))&&(this._options.method="GET",this._requestBodyBuffers=[],v(/^content-/i,this._options.headers));var o=v(/^host$/i,this._options.headers)||s.parse(this._currentUrl).hostname,n=s.resolve(this._currentUrl,r);u("redirecting to",n),this._isRedirect=!0;var i=s.parse(n);if(Object.assign(this._options,i),i.hostname!==o&&v(/^authorization$/i,this._options.headers),"function"==typeof this._options.beforeRedirect){var a={headers:e.headers};try{this._options.beforeRedirect.call(null,this._options,a);}catch(e){return void this.emit("error",e)}this._sanitizeOptions(this._options);}try{this._performRequest();}catch(e){var c=new d("Redirected request failed: "+e.message);c.cause=e,this.emit("error",c);}}else e.responseUrl=this._currentUrl,e.redirects=this._redirects,this.emit("response",e),this._requestBodyBuffers=[];},e.exports=w({http:n,https:i}),e.exports.wrap=w;},function(e,t){e.exports=url;},function(e,t,r){var s=r(0);e.exports=function(e,t){t=t||{};var r={},o=["url","method","data"],n=["headers","auth","proxy","params"],i=["baseURL","transformRequest","transformResponse","paramsSerializer","timeout","timeoutMessage","withCredentials","adapter","responseType","xsrfCookieName","xsrfHeaderName","onUploadProgress","onDownloadProgress","decompress","maxContentLength","maxBodyLength","maxRedirects","transport","httpAgent","httpsAgent","cancelToken","socketPath","responseEncoding"],a=["validateStatus"];function c(e,t){return s.isPlainObject(e)&&s.isPlainObject(t)?s.merge(e,t):s.isPlainObject(t)?s.merge({},t):s.isArray(t)?t.slice():t}function u(o){s.isUndefined(t[o])?s.isUndefined(e[o])||(r[o]=c(void 0,e[o])):r[o]=c(e[o],t[o]);}s.forEach(o,(function(e){s.isUndefined(t[e])||(r[e]=c(void 0,t[e]));})),s.forEach(n,u),s.forEach(i,(function(o){s.isUndefined(t[o])?s.isUndefined(e[o])||(r[o]=c(void 0,e[o])):r[o]=c(void 0,t[o]);})),s.forEach(a,(function(s){s in t?r[s]=c(e[s],t[s]):s in e&&(r[s]=c(void 0,e[s]));}));var h=o.concat(n).concat(i).concat(a),d=Object.keys(e).concat(Object.keys(t)).filter((function(e){return -1===h.indexOf(e)}));return s.forEach(d,u),r};},function(e,t,r){function s(e){this.message=e;}s.prototype.toString=function(){return "Cancel"+(this.message?": "+this.message:"")},s.prototype.__CANCEL__=!0,e.exports=s;},function(e,t,r){const s=r(2),{SDKError:o}=r(1);class n{constructor(e){this.api=e,this.id=null,this.data=null;}setId(e){if(!s.uuidValidate(e))throw new o(400,"[Zabo] Team id must be a valid UUID version 4. See: https://zabo.com/docs");this.id=e;}async get(){if(s.isNode()){if(!this.id)throw new o(401,"[Zabo] SDK has not initialized properly.");try{this.data=await this.api.request("GET","/teams/"+this.id);}catch(e){throw new o(e.error_type,e.message,e.request_id)}}else{if(!this.api.clientId)throw new o(401,"[Zabo] SDK has not initialized properly.");try{const e=encodeURIComponent(window?window.location.host:"");this.data=await this.api.request("GET",`/teams/info?client_id=${this.api.clientId}&origin=${e}`,{},!0);}catch(e){throw new o(e.error_type,e.message,e.request_id)}}return this.data}async getSession(){const e=this.data&&this.data.session;if(e&&new Date(e.expires_at)>Date.now())return e;return (await this.get()).session}}e.exports=(e,t)=>new n(e,t);},function(e,t,r){const s=r(2),{SDKError:o}=r(1);class n{constructor(e){this.api=e;}async getList({limit:e=25,cursor:t=""}={}){s.validateListParameters(e);try{return this.api.request("GET",`/currencies?limit=${e}&cursor=${t}`)}catch(e){throw new o(e.error_type,e.message,e.request_id)}}async getOne(e){if(!e)throw new o(400,"[Zabo] Missing `ticker` input. See: https://zabo.com/docs#get-specific-currency");try{return this.api.request("GET","/currencies/"+e)}catch(e){throw new o(e.error_type,e.message,e.request_id)}}async getExchangeRates({toCrypto:e=!1,limit:t=25,cursor:r="",tickers:o=""}={}){s.validateListParameters(t);let n=`/exchange-rates?to_crypto=${!!e}&limit=${t}&cursor=${r}`;return o&&(Array.isArray(o)&&(o=o.join(",")),n=`${n}&tickers=${o}`),this.api.request("GET",n)}}e.exports=e=>new n(e);},function(e,t,r){const s=r(2),{SDKError:o}=r(1);class n{constructor(e){this.api=e,this.account=null;}_setAccount(e){this.account=e;}async getOne({userId:e,accountId:t,txId:r}={}){if(s.isNode()){if(!e)throw new o(400,"[Zabo] Missing `userId` parameter. See: https://zabo.com/docs#get-a-specific-transaction");if(!s.uuidValidate(e))throw new o(400,"[Zabo] `userId` must be a valid UUID v4. See: https://zabo.com/docs#get-a-specific-transaction");if(!t)throw new o(400,"[Zabo] Missing `accountId` parameter. See: https://zabo.com/docs#get-a-specific-transaction");if(!s.uuidValidate(t))throw new o(400,"[Zabo] `accountId` must be a valid UUID v4. See: https://zabo.com/docs#get-a-specific-transaction");if(!r)throw new o(400,"[Zabo] Missing `txId` parameter. See: https://zabo.com/docs#get-a-specific-transaction");try{return this.api.request("GET",`/users/${e}/accounts/${t}/transactions/${r}`)}catch(e){throw new o(e.error_type,e.message,e.request_id)}}if(!this.account.id)throw new o(400,"[Zabo] Not connected. See: https://zabo.com/docs#connecting-a-user");if(!r)throw new o(400,"[Zabo] Missing `txId` parameter. See: https://zabo.com/docs#get-a-specific-transaction");try{return this.api.request("GET",`/accounts/${this.account.id}/transactions/${r}`)}catch(e){throw new o(e.error_type,e.message,e.request_id)}}async getList({userId:e,accountId:t,ticker:r="",limit:n=25,cursor:i=""}={}){s.validateListParameters(n);let a=null;if(s.isNode()){if(!e)throw new o(400,"[Zabo] Missing `userId` parameter. See: https://zabo.com/docs#get-transaction-history");if(!s.uuidValidate(e))throw new o(400,"[Zabo] `userId` must be a valid UUID v4. See: https://zabo.com/docs#get-transaction-history");if(!t)throw new o(400,"[Zabo] Missing `accountId` parameter. See: https://zabo.com/docs#get-transaction-history");if(!s.uuidValidate(t))throw new o(400,"[Zabo] `accountId` must be a valid UUID v4. See: https://zabo.com/docs#get-transaction-history");a=`/users/${e}/accounts/${t}/transactions?limit=${n}&cursor=${i}`,""!==r&&(a=`${a}&ticker=${r}`);}else{if(!this.account.id)throw new o(400,"[Zabo] Not connected. See: https://zabo.com/docs#connecting-a-user");a=`/accounts/${this.account.id}/transactions?limit=${n}&cursor=${i}`,""!==r&&(a=`${a}&ticker=${r}`);}try{return this.api.request("GET",a)}catch(e){throw new o(e.error_type,e.message,e.request_id)}}}e.exports=e=>new n(e);},function(e,t,r){const s=r(2),{SDKError:o}=r(1);class n{constructor(e){this.api=e;}async getList({limit:e=25,cursor:t=""}={}){s.validateListParameters(e,t);try{return this.api.request("GET",`/providers?limit=${e}&cursor=${t}`)}catch(e){throw new o(e.error_type,e.message,e.request_id)}}async getOne(e){if(!e)throw new o(400,"[Zabo] Missing `name` input. See: https://zabo.com/docs#get-a-provider");try{return this.api.request("GET","/providers/"+e)}catch(e){throw new o(e.error_type,e.message,e.request_id)}}}e.exports=e=>new n(e);},function(e,t,r){const s=r(22);e.exports=new class{async init(e={}){return await s.init(e),s}get instance(){return s}get version(){return "1.1.0"}};},function(e,t,r){const s=r(23),o=r(2),{SDKError:n}=r(1);e.exports=new class{constructor(){this.status="offline",this.api=null,this.autoConnect=!0;}async init(e){if(void 0!==e.autoConnect?this.autoConnect=e.autoConnect:this.autoConnect=!0,!o.isNode()){if(this.env=this.checkZaboEnv(e.env),!e.clientId||"string"!=typeof e.clientId)throw new n(400,"[Zabo] Please provide a valid Zabo app clientId. More details at: https://zabo.com/docs");try{this.api=new s({baseUrl:e.baseUrl,connectUrl:e.connectUrl,clientId:e.clientId,env:this.env}),await this.setEndpointAliases();}catch(e){console.error(e);}try{const e=await this.accounts.get();this.transactions._setAccount(e),this.trading._setAccount(e);}catch(e){console.info("[Zabo] No account connected yet.");}return this.api.resources.teams.get()}return e.apiKey&&e.secretKey&&"string"==typeof e.apiKey&&"string"==typeof e.secretKey?(this.env=this.checkZaboEnv(e.env),this.api=new s({baseUrl:e.baseUrl,apiKey:e.apiKey,secretKey:e.secretKey,env:this.env}),await this.setEndpointAliases(),this.autoConnect?(this.status="connecting",await this.api.connect(),this.status="online",this.api.resources.teams.id?this.api.resources.teams.get():this.throwConnectError(400,"[Zabo] Unable to connect with Zabo API. Please check your credentials and try again. More details at: https://zabo.com/docs")):void 0):this.throwConnectError(401,"[Zabo] Please provide a valid Zabo app API and Secret keys. More details at: https://zabo.com/docs#app-server-authentication")}throwConnectError(e,t){throw this.status="offline",new n(e,t)}async setEndpointAliases(){for(;!this.api.resources;)await o.sleep(500);const{teams:e,...t}=this.api.resources;Object.assign(this,t);}checkZaboEnv(e){return (e=e?e.toLowerCase():null)&&["sandbox","live"].includes(e)?e:this.throwConnectError(400,"[Zabo] Please provide a valid env, should be 'sandbox' or 'live'. More details at: https://zabo.com/docs")}connect(e={}){return this.api&&o.isBrowser()?(this.api.connect(e),this):(this.status="connecting",this.api.connect().then(e=>(this.status="online",e)).catch(e=>{throw e}))}onConnection(e){if("function"==typeof e)return this.api._onConnection=e.bind(this),this}onError(e){if("function"==typeof e)return this.api._onError=e.bind(this),this}onEvent(e){if("function"==typeof e)return this.api._onEvent=e.bind(this),this}getTeam(){return this.api.resources.teams.get()}get data(){return this.api.resources.teams.data}};},function(e,t,r){const s=r(24),o=r(46),n=r(2),i=r(49),{SDKError:a}=r(1);e.exports=class{constructor(e){if(Object.assign(this,e),!this.env)throw new a(400,"[Zabo] Please provide an 'env' value when initializing Zabo. More details at: https://zabo.com/docs");const t=o(this.baseUrl,this.connectUrl)[this.env];this.baseUrl=t.API_BASE_URL,this.axios=s.create(),this.axios.defaults.baseURL=this.baseUrl,n.isNode()?(this.axios.defaults.headers.common["X-Zabo-Key"]=this.apiKey,i(this,!0).then(e=>{this.resources=e;})):(this.connectUrl=t.CONNECT_BASE_URL,i(this,!1).then(e=>{this.resources=e;})),this._onConnectorMessage=this._onMessage.bind(this,"connector"),this._onSocketMessage=this._onMessage.bind(this,"socket"),this._isConnecting=!1,this._isWaitingForConnector=!1;}async connect({provider:e}={}){let t=null;if(n.isNode()){if(t=(await this.request("GET","/teams/id")).id,!t)throw new a(500,"[Zabo] Something went wrong on our end. Please note the time and let us know");return this.resources.teams.setId(t),t}this._isConnecting=!0;try{await window.fetch(this.connectUrl+"/health-check");let t=this.connectUrl+"/connect";t+=e&&"string"==typeof e?"/"+e:"",t+="?client_id="+this.clientId,t+="&origin="+encodeURIComponent(window.location.host),t+="&zabo_env="+this.env,t+="&zabo_version=1.1.0";const r=await this.resources.teams.getSession();r&&(t+="&otp="+r.one_time_password),this.iframe=this._appendIframe("zabo-connect-widget"),this.connector=window.open(t,this.iframe.name),this.connector.focus(),this._isWaitingForConnector=!0,this._watchConnector(r);}catch(e){this._triggerCallback("CONNECTION_FAILURE",{error_type:500,message:"Connection refused"});}}async request(e,t,r,s=!1){const o=this._buildRequest(e,t,r,s);try{const e=await this.axios(o);return e.data&&e.data.list_cursor?n.createPaginator(e.data,this):e.data}catch(e){if(e.response)throw new a(e.response.status,e.response.data.message,e.response.data.request_id);throw new a(500,e.message)}}_buildRequest(e,t,r,s){const o=Date.now(),i=this.baseUrl+t,a=r?JSON.stringify(r):"";let c={};if(n.isNode()){c={"X-Zabo-Sig":n.generateHMACSignature(this.secretKey,i,a,o),"X-Zabo-Timestamp":o};}else s||(c={Authorization:"Bearer "+n.getZaboSession()});return {method:e=e.toLowerCase(),url:i,data:r,headers:c}}_watchConnector(e){this._setListeners(e);const t=setTimeout(()=>{this._closeConnector(),this._triggerCallback("CONNECTION_FAILURE",{error_type:400,message:"Connection timeout"});},6e5),r=setInterval(()=>{this._isWaitingForConnector?this.connector.closed&&(this._closeConnector(),this._triggerCallback("CONNECTION_FAILURE",{error_type:400,message:"Connection closed"})):(this._removeListeners(),clearInterval(r),clearTimeout(t),this._closeConnector());},1e3);}_setListeners(e){if(window.addEventListener("message",this._onConnectorMessage,!1),window.WebSocket&&e){let t=new URL(this.baseUrl);t.protocol="wss:",t=t.toString()+"/ws",t+="?client_id="+this.clientId,t+="&otp="+e.one_time_password;try{this.ws=new window.WebSocket(t),this.ws.onmessage=this._onSocketMessage;}catch(e){console.warn("[Zabo] Error establishing WebSocket connection.",e.message);}}}_removeListeners(){window.removeEventListener("message",this._onConnectorMessage,!1),this.ws&&(this.ws.close(),this.ws=null);}_onMessage(e,{origin:t,data:r}){try{r=JSON.parse(r);}catch(e){}if(r.zabo){if(t!==this.connectUrl&&!/\.zabo\.com$/.test(new URL(t).hostname))throw new a(401,"[Zabo] Unauthorized attempt to call SDK from origin: "+t);switch(r.eventName){case"connectSuccess":"connector"===e&&(this._isWaitingForConnector=!1),r.account&&r.account.token&&this._setAccountSession({key:"zabosession",value:r.account.token,exp_time:r.account.exp_time}),this.resources.accounts&&this.resources.transactions&&(this.resources.accounts._setAccount(r.account),this.resources.transactions._setAccount(r.account),this.resources.trading._setAccount(r.account)),this._triggerCallback("CONNECTION_SUCCESS",r.account);break;case"connectError":"connector"===e&&(this._isWaitingForConnector=!1),this._triggerCallback("CONNECTION_FAILURE",r.error);break;case"connectClose":this._closeConnector();break;default:this._onEvent&&this._onEvent(r.eventName,r.metadata||{});}}}_setAccountSession(e){return n.setCookie(e.key,e.value,e.exp_time),!0}_appendIframe(e){let t=document.getElementsByName(e)[0];return t||(t=document.createElement("iframe"),t.setAttribute("style","position:fixed; top:0; left:0; right:0; bottom:0; z-index:2147483647;"),t.style.width="100%",t.style.height="100%",t.frameBorder=0,t.allow="usb *",t.name=e,document.body.appendChild(t)),t.style.display="block",t}_closeConnector(){this._isWaitingForConnector=!1,this.connector.closed||this.connector.close(),this.iframe&&(this.iframe.style.display="none",this.iframe.src="");}_triggerCallback(e,t){this._isConnecting&&(this._isConnecting=!1,"CONNECTION_SUCCESS"===e&&this._onConnection&&this._onConnection(t),"CONNECTION_FAILURE"===e&&this._onError&&this._onError(t));}};},function(e,t,r){e.exports=r(25);},function(e,t,r){var s=r(0),o=r(5),n=r(26),i=r(15);function a(e){var t=new n(e),r=o(n.prototype.request,t);return s.extend(r,n.prototype,t),s.extend(r,t),r}var c=a(r(7));c.Axios=n,c.create=function(e){return a(i(c.defaults,e))},c.Cancel=r(16),c.CancelToken=r(43),c.isCancel=r(6),c.all=function(e){return Promise.all(e)},c.spread=r(44),c.isAxiosError=r(45),e.exports=c,e.exports.default=c;},function(e,t,r){var s=r(0),o=r(3),n=r(27),i=r(28),a=r(15);function c(e){this.defaults=e,this.interceptors={request:new n,response:new n};}c.prototype.request=function(e){"string"==typeof e?(e=arguments[1]||{}).url=arguments[0]:e=e||{},(e=a(this.defaults,e)).method?e.method=e.method.toLowerCase():this.defaults.method?e.method=this.defaults.method.toLowerCase():e.method="get";var t=[i,void 0],r=Promise.resolve(e);for(this.interceptors.request.forEach((function(e){t.unshift(e.fulfilled,e.rejected);})),this.interceptors.response.forEach((function(e){t.push(e.fulfilled,e.rejected);}));t.length;)r=r.then(t.shift(),t.shift());return r},c.prototype.getUri=function(e){return e=a(this.defaults,e),o(e.url,e.params,e.paramsSerializer).replace(/^\?/,"")},s.forEach(["delete","get","head","options"],(function(e){c.prototype[e]=function(t,r){return this.request(a(r||{},{method:e,url:t,data:(r||{}).data}))};})),s.forEach(["post","put","patch"],(function(e){c.prototype[e]=function(t,r,s){return this.request(a(s||{},{method:e,url:t,data:r}))};})),e.exports=c;},function(e,t,r){var s=r(0);function o(){this.handlers=[];}o.prototype.use=function(e,t){return this.handlers.push({fulfilled:e,rejected:t}),this.handlers.length-1},o.prototype.eject=function(e){this.handlers[e]&&(this.handlers[e]=null);},o.prototype.forEach=function(e){s.forEach(this.handlers,(function(t){null!==t&&e(t);}));},e.exports=o;},function(e,t,r){var s=r(0),o=r(29),n=r(6),i=r(7);function a(e){e.cancelToken&&e.cancelToken.throwIfRequested();}e.exports=function(e){return a(e),e.headers=e.headers||{},e.data=o(e.data,e.headers,e.transformRequest),e.headers=s.merge(e.headers.common||{},e.headers[e.method]||{},e.headers),s.forEach(["delete","get","head","post","put","patch","common"],(function(t){delete e.headers[t];})),(e.adapter||i.adapter)(e).then((function(t){return a(e),t.data=o(t.data,t.headers,e.transformResponse),t}),(function(t){return n(t)||(a(e),t&&t.response&&(t.response.data=o(t.response.data,t.response.headers,e.transformResponse))),Promise.reject(t)}))};},function(e,t,r){var s=r(0);e.exports=function(e,t,r){return s.forEach(r,(function(r){e=r(e,t);})),e};},function(e,t,r){var s=r(0);e.exports=function(e,t){s.forEach(e,(function(r,s){s!==t&&s.toUpperCase()===t.toUpperCase()&&(e[t]=r,delete e[s]);}));};},function(e,t,r){var s=r(0),o=r(8),n=r(32),i=r(3),a=r(10),c=r(35),u=r(36),h=r(4);e.exports=function(e){return new Promise((function(t,r){var d=e.data,p=e.headers;s.isFormData(d)&&delete p["Content-Type"];var f=new XMLHttpRequest;if(e.auth){var l=e.auth.username||"",m=e.auth.password?unescape(encodeURIComponent(e.auth.password)):"";p.Authorization="Basic "+btoa(l+":"+m);}var g=a(e.baseURL,e.url);if(f.open(e.method.toUpperCase(),i(g,e.params,e.paramsSerializer),!0),f.timeout=e.timeout,f.onreadystatechange=function(){if(f&&4===f.readyState&&(0!==f.status||f.responseURL&&0===f.responseURL.indexOf("file:"))){var s="getAllResponseHeaders"in f?c(f.getAllResponseHeaders()):null,n={data:e.responseType&&"text"!==e.responseType?f.response:f.responseText,status:f.status,statusText:f.statusText,headers:s,config:e,request:f};o(t,r,n),f=null;}},f.onabort=function(){f&&(r(h("Request aborted",e,"ECONNABORTED",f)),f=null);},f.onerror=function(){r(h("Network Error",e,null,f)),f=null;},f.ontimeout=function(){var t="timeout of "+e.timeout+"ms exceeded";e.timeoutErrorMessage&&(t=e.timeoutErrorMessage),r(h(t,e,"ECONNABORTED",f)),f=null;},s.isStandardBrowserEnv()){var b=(e.withCredentials||u(g))&&e.xsrfCookieName?n.read(e.xsrfCookieName):void 0;b&&(p[e.xsrfHeaderName]=b);}if("setRequestHeader"in f&&s.forEach(p,(function(e,t){void 0===d&&"content-type"===t.toLowerCase()?delete p[t]:f.setRequestHeader(t,e);})),s.isUndefined(e.withCredentials)||(f.withCredentials=!!e.withCredentials),e.responseType)try{f.responseType=e.responseType;}catch(t){if("json"!==e.responseType)throw t}"function"==typeof e.onDownloadProgress&&f.addEventListener("progress",e.onDownloadProgress),"function"==typeof e.onUploadProgress&&f.upload&&f.upload.addEventListener("progress",e.onUploadProgress),e.cancelToken&&e.cancelToken.promise.then((function(e){f&&(f.abort(),r(e),f=null);})),d||(d=null),f.send(d);}))};},function(e,t,r){var s=r(0);e.exports=s.isStandardBrowserEnv()?{write:function(e,t,r,o,n,i){var a=[];a.push(e+"="+encodeURIComponent(t)),s.isNumber(r)&&a.push("expires="+new Date(r).toGMTString()),s.isString(o)&&a.push("path="+o),s.isString(n)&&a.push("domain="+n),!0===i&&a.push("secure"),document.cookie=a.join("; ");},read:function(e){var t=document.cookie.match(new RegExp("(^|;\\s*)("+e+")=([^;]*)"));return t?decodeURIComponent(t[3]):null},remove:function(e){this.write(e,"",Date.now()-864e5);}}:{write:function(){},read:function(){return null},remove:function(){}};},function(e,t,r){e.exports=function(e){return /^([a-z][a-z\d\+\-\.]*:)?\/\//i.test(e)};},function(e,t,r){e.exports=function(e,t){return t?e.replace(/\/+$/,"")+"/"+t.replace(/^\/+/,""):e};},function(e,t,r){var s=r(0),o=["age","authorization","content-length","content-type","etag","expires","from","host","if-modified-since","if-unmodified-since","last-modified","location","max-forwards","proxy-authorization","referer","retry-after","user-agent"];e.exports=function(e){var t,r,n,i={};return e?(s.forEach(e.split("\n"),(function(e){if(n=e.indexOf(":"),t=s.trim(e.substr(0,n)).toLowerCase(),r=s.trim(e.substr(n+1)),t){if(i[t]&&o.indexOf(t)>=0)return;i[t]="set-cookie"===t?(i[t]?i[t]:[]).concat([r]):i[t]?i[t]+", "+r:r;}})),i):i};},function(e,t,r){var s=r(0);e.exports=s.isStandardBrowserEnv()?function(){var e,t=/(msie|trident)/i.test(navigator.userAgent),r=document.createElement("a");function o(e){var s=e;return t&&(r.setAttribute("href",s),s=r.href),r.setAttribute("href",s),{href:r.href,protocol:r.protocol?r.protocol.replace(/:$/,""):"",host:r.host,search:r.search?r.search.replace(/^\?/,""):"",hash:r.hash?r.hash.replace(/^#/,""):"",hostname:r.hostname,port:r.port,pathname:"/"===r.pathname.charAt(0)?r.pathname:"/"+r.pathname}}return e=o(window.location.href),function(t){var r=s.isString(t)?o(t):t;return r.protocol===e.protocol&&r.host===e.host}}():function(){return !0};},function(e,t,r){var s=r(0),o=r(8),n=r(10),i=r(3),a=r(11),c=r(12),u=r(13).http,h=r(13).https,d=r(14),p=r(41),f=r(42),l=r(4),m=r(9),g=/https:?/;e.exports=function(e){return new Promise((function(t,r){var b=function(e){t(e);},w=function(e){r(e);},y=e.data,_=e.headers;if(_["User-Agent"]||_["user-agent"]||(_["User-Agent"]="axios/"+f.version),y&&!s.isStream(y)){if(Buffer.isBuffer(y));else if(s.isArrayBuffer(y))y=Buffer.from(new Uint8Array(y));else{if(!s.isString(y))return w(l("Data after transformation must be a string, an ArrayBuffer, a Buffer, or a Stream",e));y=Buffer.from(y,"utf-8");}_["Content-Length"]=y.length;}var v=void 0;e.auth&&(v=(e.auth.username||"")+":"+(e.auth.password||""));var E=n(e.baseURL,e.url),x=d.parse(E),S=x.protocol||"http:";if(!v&&x.auth){var q=x.auth.split(":");v=(q[0]||"")+":"+(q[1]||"");}v&&delete _.Authorization;var C=g.test(S),k=C?e.httpsAgent:e.httpAgent,T={path:i(x.path,e.params,e.paramsSerializer).replace(/^\?/,""),method:e.method.toUpperCase(),headers:_,agent:k,agents:{http:e.httpAgent,https:e.httpsAgent},auth:v};e.socketPath?T.socketPath=e.socketPath:(T.hostname=x.hostname,T.port=x.port);var R,A=e.proxy;if(!A&&!1!==A){var O=S.slice(0,-1)+"_proxy",z=process.env[O]||process.env[O.toUpperCase()];if(z){var I=d.parse(z),U=process.env.no_proxy||process.env.NO_PROXY,N=!0;if(U)N=!U.split(",").map((function(e){return e.trim()})).some((function(e){return !!e&&("*"===e||("."===e[0]&&x.hostname.substr(x.hostname.length-e.length)===e||x.hostname===e))}));if(N&&(A={host:I.hostname,port:I.port,protocol:I.protocol},I.auth)){var Z=I.auth.split(":");A.auth={username:Z[0],password:Z[1]};}}}A&&(T.headers.host=x.hostname+(x.port?":"+x.port:""),function e(t,r,s){if(t.hostname=r.host,t.host=r.host,t.port=r.port,t.path=s,r.auth){var o=Buffer.from(r.auth.username+":"+r.auth.password,"utf8").toString("base64");t.headers["Proxy-Authorization"]="Basic "+o;}t.beforeRedirect=function(t){t.headers.host=t.host,e(t,r,t.href);};}(T,A,S+"//"+x.hostname+(x.port?":"+x.port:"")+T.path));var j=C&&(!A||g.test(A.protocol));e.transport?R=e.transport:0===e.maxRedirects?R=j?c:a:(e.maxRedirects&&(T.maxRedirects=e.maxRedirects),R=j?h:u),e.maxBodyLength>-1&&(T.maxBodyLength=e.maxBodyLength);var $=R.request(T,(function(t){if(!$.aborted){var r=t,n=t.req||$;if(204!==t.statusCode&&"HEAD"!==n.method&&!1!==e.decompress)switch(t.headers["content-encoding"]){case"gzip":case"compress":case"deflate":r=r.pipe(p.createUnzip()),delete t.headers["content-encoding"];}var i={status:t.statusCode,statusText:t.statusMessage,headers:t.headers,config:e,request:n};if("stream"===e.responseType)i.data=r,o(b,w,i);else{var a=[];r.on("data",(function(t){a.push(t),e.maxContentLength>-1&&Buffer.concat(a).length>e.maxContentLength&&(r.destroy(),w(l("maxContentLength size of "+e.maxContentLength+" exceeded",e,null,n)));})),r.on("error",(function(t){$.aborted||w(m(t,e,null,n));})),r.on("end",(function(){var t=Buffer.concat(a);"arraybuffer"!==e.responseType&&(t=t.toString(e.responseEncoding),e.responseEncoding&&"utf8"!==e.responseEncoding||(t=s.stripBOM(t))),i.data=t,o(b,w,i);}));}}}));$.on("error",(function(t){$.aborted&&"ERR_FR_TOO_MANY_REDIRECTS"!==t.code||w(m(t,e,null,$));})),e.timeout&&$.setTimeout(e.timeout,(function(){$.abort(),w(l("timeout of "+e.timeout+"ms exceeded",e,"ECONNABORTED",$));})),e.cancelToken&&e.cancelToken.promise.then((function(e){$.aborted||($.abort(),w(e));})),s.isStream(y)?y.on("error",(function(t){w(m(t,e,null,$));})).pipe($):$.end(y);}))};},function(e,t){e.exports=stream;},function(e,t){e.exports=assert;},function(e,t,r){var s;try{s=r(!function(){var e=new Error("Cannot find module 'debug'");throw e.code="MODULE_NOT_FOUND",e}())("follow-redirects");}catch(e){s=function(){};}e.exports=s;},function(e,t){e.exports=zlib;},function(e){e.exports=JSON.parse('{"_args":[["axios@0.21.1","/Users/davireinke/workspace/zabo/zabo-sdk-js"]],"_from":"axios@0.21.1","_id":"axios@0.21.1","_inBundle":false,"_integrity":"sha512-dKQiRHxGD9PPRIUNIWvZhPTPpl1rf/OxTYKsqKUDjBwYylTvV7SjSHJb9ratfyzM6wCdLCOYLzs73qpg5c4iGA==","_location":"/axios","_phantomChildren":{},"_requested":{"type":"version","registry":true,"raw":"axios@0.21.1","name":"axios","escapedName":"axios","rawSpec":"0.21.1","saveSpec":null,"fetchSpec":"0.21.1"},"_requiredBy":["/"],"_resolved":"https://registry.npmjs.org/axios/-/axios-0.21.1.tgz","_spec":"0.21.1","_where":"/Users/davireinke/workspace/zabo/zabo-sdk-js","author":{"name":"Matt Zabriskie"},"browser":{"./lib/adapters/http.js":"./lib/adapters/xhr.js"},"bugs":{"url":"https://github.com/axios/axios/issues"},"bundlesize":[{"path":"./dist/axios.min.js","threshold":"5kB"}],"dependencies":{"follow-redirects":"^1.10.0"},"description":"Promise based HTTP client for the browser and node.js","devDependencies":{"bundlesize":"^0.17.0","coveralls":"^3.0.0","es6-promise":"^4.2.4","grunt":"^1.0.2","grunt-banner":"^0.6.0","grunt-cli":"^1.2.0","grunt-contrib-clean":"^1.1.0","grunt-contrib-watch":"^1.0.0","grunt-eslint":"^20.1.0","grunt-karma":"^2.0.0","grunt-mocha-test":"^0.13.3","grunt-ts":"^6.0.0-beta.19","grunt-webpack":"^1.0.18","istanbul-instrumenter-loader":"^1.0.0","jasmine-core":"^2.4.1","karma":"^1.3.0","karma-chrome-launcher":"^2.2.0","karma-coverage":"^1.1.1","karma-firefox-launcher":"^1.1.0","karma-jasmine":"^1.1.1","karma-jasmine-ajax":"^0.1.13","karma-opera-launcher":"^1.0.0","karma-safari-launcher":"^1.0.0","karma-sauce-launcher":"^1.2.0","karma-sinon":"^1.0.5","karma-sourcemap-loader":"^0.3.7","karma-webpack":"^1.7.0","load-grunt-tasks":"^3.5.2","minimist":"^1.2.0","mocha":"^5.2.0","sinon":"^4.5.0","typescript":"^2.8.1","url-search-params":"^0.10.0","webpack":"^1.13.1","webpack-dev-server":"^1.14.1"},"homepage":"https://github.com/axios/axios","jsdelivr":"dist/axios.min.js","keywords":["xhr","http","ajax","promise","node"],"license":"MIT","main":"index.js","name":"axios","repository":{"type":"git","url":"git+https://github.com/axios/axios.git"},"scripts":{"build":"NODE_ENV=production grunt build","coveralls":"cat coverage/lcov.info | ./node_modules/coveralls/bin/coveralls.js","examples":"node ./examples/server.js","fix":"eslint --fix lib/**/*.js","postversion":"git push && git push --tags","preversion":"npm test","start":"node ./sandbox/server.js","test":"grunt test && bundlesize","version":"npm run build && grunt version && git add -A dist && git add CHANGELOG.md bower.json package.json"},"typings":"./index.d.ts","unpkg":"dist/axios.min.js","version":"0.21.1"}');},function(e,t,r){var s=r(16);function o(e){if("function"!=typeof e)throw new TypeError("executor must be a function.");var t;this.promise=new Promise((function(e){t=e;}));var r=this;e((function(e){r.reason||(r.reason=new s(e),t(r.reason));}));}o.prototype.throwIfRequested=function(){if(this.reason)throw this.reason},o.source=function(){var e;return {token:new o((function(t){e=t;})),cancel:e}},e.exports=o;},function(e,t,r){e.exports=function(e){return function(t){return e.apply(null,t)}};},function(e,t,r){e.exports=function(e){return "object"==typeof e&&!0===e.isAxiosError};},function(e,t,r){const{isBrowser:s}=r(2);e.exports=(e,t)=>{let r,o;return e&&""!==e?(r=e,s()&&(o=t)):(r="https://api.zabo.com",s()&&(o="https://connect.zabo.com")),{sandbox:{API_BASE_URL:r+"/sandbox-v1",CONNECT_BASE_URL:o},live:{API_BASE_URL:r+"/v1",CONNECT_BASE_URL:o}}};},function(e,t,r){e.exports=r(48).createHmac;},function(e,t){e.exports=crypto;},function(e,t,r){e.exports=async(e,t)=>{if(t)return {users:r(50)(e),teams:r(17)(e),blockchains:r(51)(e),currencies:r(18)(e),transactions:r(19)(e),providers:r(20)(e)};return {teams:r(17)(e),accounts:r(52)(e),trading:r(53)(e),currencies:r(18)(e),transactions:r(19)(e),providers:r(20)(e)}};},function(e,t,r){const s=r(2),{SDKError:o}=r(1);class n{constructor(e){this.api=e;}async create(e={}){if(!e.id)throw new o(400,"[Zabo] Missing `id` property in account object. See: https://zabo.com/docs#create-a-user");if(!e.token)throw new o(400,"[Zabo] Missing `token` property in account object. See: https://zabo.com/docs#create-a-user");try{return this.api.request("POST","/users",e)}catch(e){throw new o(e.error_type,e.message,e.request_id)}}async addAccount(e={},t={}){if(!e.id)throw new o(400,"[Zabo] Missing `id` property in user object. See: https://zabo.com/docs#add-account-to-existing-user");if(!t.id)throw new o(400,"[Zabo] Missing `id` property in account object. See: https://zabo.com/docs#add-account-to-existing-user");if(!t.token)throw new o(400,"[Zabo] Missing `token` property in account object. See: https://zabo.com/docs#add-account-to-existing-user");try{return this.api.request("POST",`/users/${e.id}/accounts`,t)}catch(e){throw new o(e.error_type,e.message,e.request_id)}}async removeAccount({userId:e,accountId:t}){if(!e)throw new o(400,"[Zabo] Missing `id` property in user object. See: https://zabo.com/docs#remove-account-from-user");if(!t)throw new o(400,"[Zabo] Missing `id` property in account object. See: https://zabo.com/docs#remove-account-from-user");try{return this.api.request("DELETE",`/users/${e}/accounts/${t}`)}catch(e){throw new o(e.error_type,e.message,e.request_id)}}async getOne(e){if(!e)throw new o(400,"[Zabo] Missing `id` input. See: https://zabo.com/docs#get-a-user");try{return this.api.request("GET","/users/"+e)}catch(e){throw new o(e.error_type,e.message,e.request_id)}}async getList({limit:e=25,cursor:t=""}={}){s.validateListParameters(e,t);try{return this.api.request("GET",`/users?limit=${e}&cursor=${t}`)}catch(e){throw new o(e.error_type,e.message,e.request_id)}}async getAccount({userId:e,accountId:t}={}){if(!e)throw new o(400,"[Zabo] Missing `userId` parameter. See: https://zabo.com/docs#get-a-user-account");if(!t)throw new o(400,"[Zabo] Missing `accountId` parameter. See: https://zabo.com/docs#get-a-user-account");try{return this.api.request("GET",`/users/${e}/accounts/${t}`)}catch(e){throw new o(e.error_type,e.message,e.request_id)}}async getBalances({userId:e,accountId:t,tickers:r}={}){if(!e)throw new o(400,"[Zabo] Missing `userId` parameter. See: https://zabo.com/docs#get-a-specific-balance");if(!t)throw new o(400,"[Zabo] Missing `accountId` parameter. See: https://zabo.com/docs#get-a-specific-balance");let s=`/users/${e}/accounts/${t}/balances`;r&&(Array.isArray(r)&&(r=r.join(",")),s=`${s}?tickers=${r}`);try{return this.api.request("GET",s)}catch(e){throw new o(e.error_type,e.message,e.request_id)}}async createDepositAddress({userId:e,accountId:t,ticker:r}={}){if(!e)throw new o(400,"[Zabo] Missing `userId` parameter. See: https://zabo.com/docs#create-a-deposit-address");if(!t)throw new o(400,"[Zabo] Missing `accountId` parameter. See: https://zabo.com/docs#create-a-deposit-address");if(!r||"string"!=typeof r)throw new o(400,"[Zabo] Missing or invalid `ticker` parameter. See: https://zabo.com/docs#create-a-deposit-address");try{return this.api.request("POST",`/users/${e}/accounts/${t}/deposit-addresses?ticker=${r}`)}catch(e){throw new o(e.error_type,e.message,e.request_id)}}async getDepositAddresses({userId:e,accountId:t,ticker:r}={}){if(!e)throw new o(400,"[Zabo] Missing `userId` parameter. See: https://zabo.com/docs#get-deposit-addresses");if(!t)throw new o(400,"[Zabo] Missing `accountId` parameter. See: https://zabo.com/docs#get-deposit-addresses");if(!r||"string"!=typeof r)throw new o(400,"[Zabo] Missing or invalid `ticker` parameter. See: https://zabo.com/docs#get-deposit-addresses");try{return this.api.request("GET",`/users/${e}/accounts/${t}/deposit-addresses?ticker=${r}`)}catch(e){throw new o(e.error_type,e.message,e.request_id)}}}e.exports=e=>new n(e);},function(e,t,r){const s=r(2),{SDKError:o}=r(1);class n{constructor(e){this.api=e;}async getBlock(e,t){s.validateEnumParameter("blockchain",e,["bitcoin","ethereum"]);let r=`/blockchains/${e}/blocks`;void 0!==t&&(r+="/"+t);try{return this.api.request("GET",r)}catch(e){throw new o(e.error_type,e.message,e.request_id)}}async getContract(e,t){if(s.validateEnumParameter("blockchain",e,["ethereum"]),void 0===t)throw new o(400,"[Zabo] Missing `address` parameter. See: https://zabo.com/docs#get-a-smart-contract");try{return this.api.request("GET",`/blockchains/${e}/contracts/${t}`)}catch(e){throw new o(e.error_type,e.message,e.request_id)}}async getTokens(e,t){s.validateEnumParameter("blockchain",e,["ethereum"]);let r=`/blockchains/${e}/tokens`;void 0!==t&&(r+="/"+t);try{return this.api.request("GET",r)}catch(e){throw new o(e.error_type,e.message,e.request_id)}}async getBalances(e,t){if(s.validateEnumParameter("blockchain",e,["bitcoin","ethereum"]),void 0===t)throw new o(400,"[Zabo] Missing `address` parameter. See: https://zabo.com/docs#get-balances-for-address-or-xpub");try{return this.api.request("GET",`/blockchains/${e}/addresses/${t}/balances`)}catch(e){throw new o(e.error_type,e.message,e.request_id)}}async getTransactions(e,t){if(s.validateEnumParameter("blockchain",e,["bitcoin","ethereum"]),void 0===t)throw new o(400,"[Zabo] Missing `address` parameter. See: https://zabo.com/docs#get-transactions-for-address-or-xpub");try{return this.api.request("GET",`/blockchains/${e}/addresses/${t}/transactions`)}catch(e){throw new o(e.error_type,e.message,e.request_id)}}async getTransaction(e,t){if(s.validateEnumParameter("blockchain",e,["bitcoin","ethereum"]),void 0===t)throw new o(400,"[Zabo] Missing `transactionHash` parameter. See: https://zabo.com/docs#get-transaction-by-hash");try{return this.api.request("GET",`/blockchains/${e}/transactions/${t}`)}catch(e){throw new o(e.error_type,e.message,e.request_id)}}async getTokenTransfers(e,t){if(s.validateEnumParameter("blockchain",e,["ethereum"]),void 0===t)throw new o(400,"[Zabo] Missing `address` parameter. See: https://zabo.com/docs#get-token-transfers-for-address-or-xpub");try{return this.api.request("GET",`/blockchains/${e}/addresses/${t}/token-transfers`)}catch(e){throw new o(e.error_type,e.message,e.request_id)}}async getTokenTransfer(e,t){if(s.validateEnumParameter("blockchain",e,["ethereum"]),void 0===t)throw new o(400,"[Zabo] Missing `transactionHash` parameter. See: https://zabo.com/docs#get-a-token-transfer-by-hash");try{return this.api.request("GET",`/blockchains/${e}/token-transfers/${t}`)}catch(e){throw new o(e.error_type,e.message,e.request_id)}}}e.exports=e=>new n(e);},function(e,t,r){const{SDKError:s}=r(1);class o{constructor(e){this.api=e,this.id=null,this.data=null;}_setAccount(e){this.id=e.id,this.data=e;}async get(){try{const e=await this.api.request("GET","/sessions");return this._setAccount(e),this.data}catch(e){throw new s(e.error_type,e.message,e.request_id)}}async create({clientId:e,credentials:t,provider:r,origin:o}={}){if(!e)throw new s(400,"[Zabo] Unable to connect with the Zabo API. Make sure you have registered your app at https://zabo.com and that you entered a valid 'clientId' value.\n        More details at: https://zabo.com/docs");const n={client_id:e,provider_name:r,credentials:t,origin:o};try{const e=await this.api.request("POST","/accounts",n);return this._setAccount(e),e}catch(e){throw new s(e.error_type,e.message,e.request_id)}}async getBalances({tickers:e}={}){if(!this.id)throw new s(401,"[Zabo] Account not yet connected. See: https://zabo.com/docs#connecting-a-user");let t=`/accounts/${this.id}/balances`;e&&(Array.isArray(e)&&(e=e.join(",")),t=`${t}?tickers=${e}`);try{return this.api.request("GET",t)}catch(e){throw new s(e.error_type,e.message,e.request_id)}}async createDepositAddress(e){if(!this.id)throw new s(401,"[Zabo] Account not yet connected. See: https://zabo.com/docs#connecting-a-user");if(!e||"string"!=typeof e)throw new s(400,"[Zabo] Missing or invalid `ticker` parameter. See: https://zabo.com/docs#create-a-deposit-address");const t=["metamask","ledger","hedera","address-only","binance"];for(const r of t)if(r===this.data.provider.name)return console.warn(`[Zabo] Provider '${r}' does not support dynamic address generation. Fallbacking to accounts.getDepositAddresses()... More details: https://zabo.com/docs#get-deposit-addresses`),this.getDepositAddresses(e);try{return this.api.request("POST",`/accounts/${this.id}/deposit-addresses?ticker=${e}`)}catch(e){throw new s(e.error_type,e.message,e.request_id)}}async getDepositAddresses(e){if(!this.id)throw new s(401,"[Zabo] Account not yet connected. See: https://zabo.com/docs#connecting-a-user");if(!e||"string"!=typeof e)throw new s(400,"[Zabo] Invalid `ticker` parameter. See: https://zabo.com/docs#get-deposit-addresses");try{return this.api.request("GET",`/accounts/${this.id}/deposit-addresses?ticker=${e}`)}catch(e){throw new s(e.error_type,e.message,e.request_id)}}}e.exports=e=>new o(e);},function(e,t,r){const s=r(2),{SDKError:o}=r(1);class n{constructor(e){this.api=e,this.account=null;}_setAccount(e){this.account=e;}async getSymbols(){if(!this.account||!this.account.id)throw new o(400,"[Zabo] Not connected. See: https://zabo.com/docs#connecting-a-user");try{return this.api.request("GET",`/accounts/${this.account.id}/trading-symbols`)}catch(e){throw new o(e.error_type,e.message,e.request_id)}}async getTickerInfo({baseCurrency:e,quoteCurrency:t}={}){if(!this.account||!this.account.id)throw new o(400,"[Zabo] Not connected. See: https://zabo.com/docs#connecting-a-user");if(!e)throw new o(400,"[Zabo] Missing `baseCurrency` parameter. See: https://zabo.com/docs/#get-ticker-info");if(!t)throw new o(400,"[Zabo] Missing `quoteCurrency` parameter. See: https://zabo.com/docs/#get-ticker-info");try{return this.api.request("GET",`/accounts/${this.account.id}/tickers/${e}-${t}`)}catch(e){throw new o(e.error_type,e.message,e.request_id)}}async getOrders(){if(!this.account||!this.account.id)throw new o(400,"[Zabo] Not connected. See: https://zabo.com/docs#connecting-a-user");try{return this.api.request("GET",`/accounts/${this.account.id}/orders`)}catch(e){throw new o(e.error_type,e.message,e.request_id)}}async getOrder({orderId:e}={}){if(!this.account||!this.account.id)throw new o(400,"[Zabo] Not connected. See: https://zabo.com/docs#connecting-a-user");if(!e)throw new o(400,"[Zabo] Missing `orderId` parameter. See: https://zabo.com/docs/#get-an-order");if(!s.uuidValidate(e))throw new o(400,"[Zabo] `orderId` must be a valid UUID v4. See: https://zabo.com/docs/#get-an-order");try{return this.api.request("GET",`/accounts/${this.account.id}/orders/${e}`)}catch(e){throw new o(e.error_type,e.message,e.request_id)}}async createOrder({baseCurrency:e,quoteCurrency:t,buyOrSell:r,priceLimit:n,baseAmount:i,quoteAmount:a,provideLiquidityOnly:c,timeInForce:u,ttl:h}={}){if(!this.account||!this.account.id)throw new o(400,"[Zabo] Not connected. See: https://zabo.com/docs#connecting-a-user");if(!e)throw new o(400,"[Zabo] Missing `baseCurrency` parameter. See: https://zabo.com/docs/#place-new-order");if(!t)throw new o(400,"[Zabo] Missing `quoteCurrency` parameter. See: https://zabo.com/docs/#place-new-order");if(void 0!==i&&i<=0)throw new o(400,"[Zabo] `baseAmount` must be greater than 0. See: https://zabo.com/docs/#place-new-order");if(void 0!==a&&a<=0)throw new o(400,"[Zabo] `quoteAmount` must be greater than 0. See: https://zabo.com/docs/#place-new-order");if(void 0!==n&&n<=0)throw new o(400,"[Zabo] `priceLimit` must be greater than 0. See: https://zabo.com/docs/#place-new-order");s.validateEnumParameter("buyOrSell",r,["buy","sell"]),s.validateEnumParameter("timeInForce",u,["GTC","GTT","IOC","FOK"],!0);try{return this.api.request("POST",`/accounts/${this.account.id}/orders`,{base_currency:e,quote_currency:t,buy_or_sell:r,price_limit:n,base_amount:i,quote_amount:a,provide_liquidity_only:c,time_in_force:u,ttl:h})}catch(e){throw new o(e.error_type,e.message,e.request_id)}}async cancelOrders(){if(!this.account||!this.account.id)throw new o(400,"[Zabo] Not connected. See: https://zabo.com/docs#connecting-a-user");try{return this.api.request("DELETE",`/accounts/${this.account.id}/orders`)}catch(e){throw new o(e.error_type,e.message,e.request_id)}}async cancelOrder({orderId:e}={}){if(!this.account||!this.account.id)throw new o(400,"[Zabo] Not connected. See: https://zabo.com/docs#connecting-a-user");if(!e)throw new o(400,"[Zabo] Missing `orderId` parameter. See: https://zabo.com/docs/#cancel-an-order");if(!s.uuidValidate(e))throw new o(400,"[Zabo] `orderId` must be a valid UUID v4. See: https://zabo.com/docs/#cancel-an-order");try{return this.api.request("DELETE",`/accounts/${this.account.id}/orders/${e}`)}catch(e){throw new o(e.error_type,e.message,e.request_id)}}}e.exports=e=>new n(e);}])}));
});

var Zabo = unwrapExports(dist);
var dist_1 = dist.Zabo;

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css = ".styles_zaboButton__3gjAo {\n  font-weight: bold;\n  text-transform: uppercase;\n  border: none;\n  border-radius: 4px;\n  padding: 8px 16px;\n  color: #FFFFFF;\n  background-image: linear-gradient(135deg, #39F1FF 0%, #5C6FEA 51%, #D693FF 100%);\n  background-size: 100% 200%;\n  transition: all 0.3s;\n}\n.styles_zaboButton__3gjAo:hover {\n  background-position-y: 100%;\n}\n.styles_zaboButton__3gjAo * {\n  vertical-align: middle;\n}\n.styles_zaboButton__3gjAo svg {\n  fill: currentColor;\n  margin-right: 8px;\n  width: 20px;\n}\n";
var styles = { "zaboButton": "styles_zaboButton__3gjAo" };
styleInject(css);

var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();

var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};

var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};

var ZaboComponent = function (_Component) {
  inherits(ZaboComponent, _Component);

  function ZaboComponent() {
    var _ref;

    var _temp, _this, _ret;

    classCallCheck(this, ZaboComponent);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = possibleConstructorReturn(this, (_ref = ZaboComponent.__proto__ || Object.getPrototypeOf(ZaboComponent)).call.apply(_ref, [this].concat(args))), _this), _this.onInit = _this.onInit.bind(_this), _this.onConnect = _this.onConnect.bind(_this), _this.onError = _this.onError.bind(_this), _this.connect = _this.connect.bind(_this), _temp), possibleConstructorReturn(_this, _ret);
  }

  // HANDLERS


  createClass(ZaboComponent, [{
    key: 'onInit',
    value: function onInit(zabo) {
      var onInit = this.props.onInit;

      if (onInit) onInit(zabo.data, zabo);
    }
  }, {
    key: 'onConnect',
    value: function onConnect(account) {
      var onConnect = this.props.onConnect;

      if (onConnect) onConnect(account, Zabo.instance);
    }
  }, {
    key: 'onError',
    value: function onError(err) {
      var onError = this.props.onError;

      if (onError) onError(err);
    }
  }, {
    key: 'connect',
    value: function connect() {
      if (Zabo.instance) {
        Zabo.instance.connect().onConnection(this.onConnect).onError(this.onError);
      }
    }
  }, {
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _props = this.props,
          clientId = _props.clientId,
          env = _props.env;


      Zabo.init({
        clientId: clientId,
        env: env || 'sandbox'
      }).then(this.onInit).catch(this.onError);
    }
  }, {
    key: 'render',
    value: function render() {
      var children = this.props.children;


      return React.createElement(
        'div',
        { onClick: this.connect },
        children || React.createElement(
          'button',
          { className: styles.zaboButton },
          React.createElement(
            'svg',
            { xmlns: 'http://www.w3.org/2000/svg', viewBox: '0 0 200 170' },
            React.createElement('path', { d: 'M128.94,110.68L35.26,170.4H200l-35-59.72H128.94Zm70.81-48.13H71.06L0,107.85l35,59.72,93.67-59.72ZM71.06,59.72H200L165,0H0.25l35,59.72h35.8Z' })
          ),
          React.createElement(
            'span',
            null,
            'CONNECT YOUR WALLET'
          )
        )
      );
    }
  }]);
  return ZaboComponent;
}(Component);

ZaboComponent.propTypes = {
  clientId: PropTypes.string.isRequired,
  env: PropTypes.oneOf(['sandbox', 'live']),
  onInit: PropTypes.func,
  onConnect: PropTypes.func,
  onError: PropTypes.func };

export default ZaboComponent;
//# sourceMappingURL=index.es.js.map
